/*
 Δραστηριότητα 1.22
 Οδήγηση κινητήρα και έλεγχος κίνησης
*/
#include <Wire.h>
#include <Adafruit_PWMServoDriver.h>
Adafruit_PWMServoDriver pwm = Adafruit_PWMServoDriver(0x47);

int speeds = 1000;     // αρχικοποίηση της τιμής ταχύτητας
int turnSpeed = 2000;  // αρχικοποίηση της τιμής ταχύτητας για τις στροφές


void setup() {
  Serial.begin(9600);  // Ορίζει το ρυθμό baud σε 9600
  pwm.begin();

  pwm.setPWMFreq(60);
  stop();  // το ρομπότ σταματάει
}

void loop() {
  // Κινείται μπροστά για ένα δευτερόλεπτο
  advance();
  delay(1000);

  // Κινείται πίσω για 1 δευτερόλεπτο
  back();
  delay(1000);

  // Στρίβει αριστερά για 1 δευτερόλεπτο
  turnL();
  delay(1000);

  // Στρίβει δεξιά για 1 δευτερόλεπτο
  turnR();
  delay(1000);

  // Σταμάτα για 1 δευτερόλεπτο, έπειτα επαναλαμβάνεται η διαδικασία.
  stop();
  delay(1000);
}

void advance()  // Κίνηση μπροστά
{
  pwm.setPWM(0, 0, speeds);
  pwm.setPWM(1, 0, 0);
  pwm.setPWM(2, 0, speeds);
  pwm.setPWM(3, 0, 0);
  pwm.setPWM(4, 0, speeds);
  pwm.setPWM(5, 0, 0);
  pwm.setPWM(6, 0, speeds);
  pwm.setPWM(7, 0, 0);
}

void turnR()  // Δεξια στροφή
{
  pwm.setPWM(0, 0, turnSpeed);
  pwm.setPWM(1, 0, 0);
  pwm.setPWM(2, 0, turnSpeed);
  pwm.setPWM(3, 0, 0);
  pwm.setPWM(4, 0, 0);
  pwm.setPWM(5, 0, turnSpeed);
  pwm.setPWM(6, 0, 0);
  pwm.setPWM(7, 0, turnSpeed);
}

void turnL()  // Αριστερά στροφή
{
  pwm.setPWM(0, 0, 0);
  pwm.setPWM(1, 0, turnSpeed);
  pwm.setPWM(2, 0, 0);
  pwm.setPWM(3, 0, turnSpeed);
  pwm.setPWM(4, 0, turnSpeed);
  pwm.setPWM(5, 0, 0);
  pwm.setPWM(6, 0, turnSpeed);
  pwm.setPWM(7, 0, 0);
}

void stop()  // Σταματάει
{
  pwm.setPWM(0, 0, 0);
  pwm.setPWM(1, 0, 0);
  pwm.setPWM(2, 0, 0);
  pwm.setPWM(3, 0, 0);
  pwm.setPWM(4, 0, 0);
  pwm.setPWM(5, 0, 0);
  pwm.setPWM(6, 0, 0);
  pwm.setPWM(7, 0, 0);
}

void back()  // Κίνηση προς τα πίσω
{
  pwm.setPWM(0, 0, 0);
  pwm.setPWM(1, 0, speeds);
  pwm.setPWM(2, 0, 0);
  pwm.setPWM(3, 0, speeds);
  pwm.setPWM(4, 0, 0);
  pwm.setPWM(5, 0, speeds);
  pwm.setPWM(6, 0, 0);
  pwm.setPWM(7, 0, speeds);
}