#include <Wire.h>
#include <Adafruit_PWMServoDriver.h>
Adafruit_PWMServoDriver pwm = Adafruit_PWMServoDriver(0x47);
int BUZZER_PIN = 2;    // Ορισμός βομβητή στο PIN 2
int Red_Led = 3;       //  Ορισμός κόκκινου LED στο PIN 3
int speed = 2000;      // Αρχικοποίηση της τιμής ταχύτητας
int turnSpeed = 2000;  // Αρχικοποίηση της τιμής ταχύτητας για τις στροφές
int echoPin = 13;      // Ορισμός μονάδα υπερήχων ECHO στο D13
int trigPin = 12;      // Ορισμός μονάδα υπερήχων TRIG στο D12

int Ultrasonic_Ranging() {
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  int distance = pulseIn(echoPin, HIGH);  // Ανάγνωση της διάρκειας των υψηλών επιπέδων
  distance = distance / 58;               // Μετατροπή του χρόνου παλμού σε απόσταση
  delay(50);
  return distance;
}

void setup() {
  Serial.begin(9600);           // Έναρξη σειριακής θύρας στη συχνότητα 9600
  pinMode(Red_Led, OUTPUT);     // Pin κόκκινου LED
  pinMode(BUZZER_PIN, OUTPUT);  // Pin βομβητή
  pwm.begin();
  pwm.setPWMFreq(60);
  stop();
}

void loop() {
  int distance = Ultrasonic_Ranging();
  if (distance >= 20 && distance <= 40) {  // Ελέγχει αν η απόσταση είναι μεταξύ 20 και 40 εκατοστά
    digitalWrite(Red_Led, HIGH);           // Το κόκκινο LED ενεργοποιείται
    advance();
    digitalWrite(BUZZER_PIN, LOW);   // Ο βομβητής απενεργοποιείται
  } else if (distance < 20) {        // Ελέγχει αν η απόσταση είναι μικρότερη απο 20 εκατοστά
    digitalWrite(Red_Led, LOW);      // Το κόκκινο LED απενεργοποιείται
    digitalWrite(BUZZER_PIN, HIGH);  // Ο βομβητής ενεργοποιείται
    back();
    delay(1000);
    digitalWrite(BUZZER_PIN, LOW);  // Ο βομβητής απενεργοποιείται
  } else {
    digitalWrite(Red_Led, LOW);  // Το κόκκινο LED απενεργοποιείται
    stop();
    digitalWrite(BUZZER_PIN, LOW);  // Ο βομβητής απενεργοποιείται
  }
}

void advance()  // Κίνηση μπροστά
{
  pwm.setPWM(0, 0, speed);
  pwm.setPWM(1, 0, 0);
  pwm.setPWM(2, 0, speed);
  pwm.setPWM(3, 0, 0);
  pwm.setPWM(4, 0, speed);
  pwm.setPWM(5, 0, 0);
  pwm.setPWM(6, 0, speed);
  pwm.setPWM(7, 0, 0);

  }

void turnR()  // Στροφή δεξιά
{
  pwm.setPWM(0, 0, turnSpeed);
  pwm.setPWM(1, 0, 0);
  pwm.setPWM(2, 0, turnSpeed);
  pwm.setPWM(3, 0, 0);
  pwm.setPWM(4, 0, 0);
  pwm.setPWM(5, 0, turnSpeed);
  pwm.setPWM(6, 0, 0);
  pwm.setPWM(7, 0, turnSpeed);
}

void turnL()  // Στροφή αριστερά
{
  pwm.setPWM(0, 0, 0);
  pwm.setPWM(1, 0, turnSpeed);
  pwm.setPWM(2, 0, 0);
  pwm.setPWM(3, 0, turnSpeed);
  pwm.setPWM(4, 0, turnSpeed);
  pwm.setPWM(5, 0, 0);
  pwm.setPWM(6, 0, turnSpeed);
  pwm.setPWM(7, 0, 0);
}


void stop()  // Σταματάει
{
  pwm.setPWM(0, 0, 0);
  pwm.setPWM(1, 0, 0);
  pwm.setPWM(2, 0, 0);
  pwm.setPWM(3, 0, 0);
  pwm.setPWM(4, 0, 0);
  pwm.setPWM(5, 0, 0);
  pwm.setPWM(6, 0, 0);
  pwm.setPWM(7, 0, 0);
}

void back()  // Κίνηση προς τα πίσω
{
  pwm.setPWM(0, 0, 0);
  pwm.setPWM(1, 0, speed);
  pwm.setPWM(2, 0, 0);
  pwm.setPWM(3, 0, speed);
  pwm.setPWM(4, 0, 0);
  pwm.setPWM(5, 0, speed);
  pwm.setPWM(6, 0, 0);
  pwm.setPWM(7, 0, speed);
}
