#include <Wire.h>
#include <Adafruit_PWMServoDriver.h>
Adafruit_PWMServoDriver pwm = Adafruit_PWMServoDriver(0x47);
int speed = 2000;      // Αρχικοποίηση της τιμής ταχύτητας
int turnSpeed = 2000;  // Αρχικοποίηση της τιμής ταχύτητας για τις στροφές
int echoPin = 13;  // Ορισμός μονάδα υπερήχων ECHO στο D13
int trigPin = 12;  // Ορισμός μονάδα υπερήχων TRIG στο D12

void setup() {
  Serial.begin(9600);           // Έναρξη σειριακής θύρας στη συχνότητα 9600
  pwm.begin();
  pwm.setPWMFreq(60);
  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
  stop();
}

void loop() {
  if (Serial.available() > 0) {
    switch (Serial.read()) {
      case 'F': advance(); Serial.println("advance"); break; // Αν λάβει εντολή ‘F’, κάνει κίνηση μπροστά
      case 'B': back(); Serial.println("back"); break; // Αν λάβει εντολή ‘B’, κάνει κίνηση πίσω
      case 'S': stop(); Serial.println("stop"); break;  // Αν λάβει εντολή ‘S’, σταματάει
      default : break;
    }
  }
}

void advance()  // Κίνηση μπροστά
{
  pwm.setPWM(0, 0, speed);
  pwm.setPWM(1, 0, 0);
  pwm.setPWM(2, 0, speed);
  pwm.setPWM(3, 0, 0);
  pwm.setPWM(4, 0, speed);
  pwm.setPWM(5, 0, 0);
  pwm.setPWM(6, 0, speed);
  pwm.setPWM(7, 0, 0);
}

void back()  // Κίνηση προς τα πίσω
{
  pwm.setPWM(0, 0, 0);
  pwm.setPWM(1, 0, speed);
  pwm.setPWM(2, 0, 0);
  pwm.setPWM(3, 0, speed);
  pwm.setPWM(4, 0, 0);
  pwm.setPWM(5, 0, speed);
  pwm.setPWM(6, 0, 0);
  pwm.setPWM(7, 0, speed);
}

void stop()  // Σταματάει
{
  pwm.setPWM(0, 0, 0);
  pwm.setPWM(1, 0, 0);
  pwm.setPWM(2, 0, 0);
  pwm.setPWM(3, 0, 0);
  pwm.setPWM(4, 0, 0);
  pwm.setPWM(5, 0, 0);
  pwm.setPWM(6, 0, 0);

  pwm.setPWM(7, 0, 0);
}
