/*
 Δραστηριότητα 1.41
 Έλεγχος αυτοκινήτου με το τηλεχειριστήριο IR (4)
*/
#include <Wire.h>
#include <Adafruit_PWMServoDriver.h>
#include <IRremote.h>
Adafruit_PWMServoDriver pwm = Adafruit_PWMServoDriver(0x47);
int RECV_PIN = A0;
int speed = 2000;      // Αρχικοποίηση της τιμής ταχύτητας
int turnSpeed = 2000;  // Αρχικοποίηση της τιμής ταχύτητας για τις στροφές

#define IR_Go 70
#define IR_Back 21
#define IR_Left 68
#define IR_Right 67
#define IR_Stop 64

void setup() {
  Serial.begin(9600);
  pwm.begin();
  pwm.setPWMFreq(60);
  IrReceiver.begin(RECV_PIN);  // ενεργοποίηση του δέκτη IR
  stop();
}

void loop() {
  if (IrReceiver.decode()) {
    switch (IrReceiver.decodedIRData.command) {
      case IR_Go:
        advance();  // Όταν πατηθεί το πάνω κουμπί, το ρομπότ κινείται προς τα μπρος
        break;
      case IR_Left:
        turnL();  // Όταν πατηθεί το αριστερό κουμπί, το ρομπότ στρίβει προς τα αριστερά
        break;
      case IR_Stop:
        stop();  // Όταν πατηθεί το ΌΚ΄ κουμπί, το ρομπότ σταματάει.
        break;
      default: break;
    }
    IrReceiver.resume();
  }
}

void advance()  // Κίνηση μπροστά
{
  pwm.setPWM(0, 0, speed);
  pwm.setPWM(1, 0, 0);
  pwm.setPWM(2, 0, speed);
  pwm.setPWM(3, 0, 0);
  pwm.setPWM(4, 0, speed);
  pwm.setPWM(5, 0, 0);
  pwm.setPWM(6, 0, speed);
  pwm.setPWM(7, 0, 0);
}

void turnL()  // Στροφή αριστερά
{
  pwm.setPWM(0, 0, 0);
  pwm.setPWM(1, 0, turnSpeed);
  pwm.setPWM(2, 0, 0);
  pwm.setPWM(3, 0, turnSpeed);
  pwm.setPWM(4, 0, turnSpeed);
  pwm.setPWM(5, 0, 0);
  pwm.setPWM(6, 0, turnSpeed);
  pwm.setPWM(7, 0, 0);
}

void stop()  // Σταματάει
{
  pwm.setPWM(0, 0, 0);
  pwm.setPWM(1, 0, 0);
  pwm.setPWM(2, 0, 0);
  pwm.setPWM(3, 0, 0);
  pwm.setPWM(4, 0, 0);
  pwm.setPWM(5, 0, 0);
  pwm.setPWM(6, 0, 0);
  pwm.setPWM(7, 0, 0);
}