/*
 Δραστηριότητα 1.44
 Έλεγχος ταχύτητας έξυπνου αυτοκινήτου (2)
*/
#include <Wire.h>
#include <Adafruit_PWMServoDriver.h>
Adafruit_PWMServoDriver pwm = Adafruit_PWMServoDriver(0x47);
int speed = 2000;      // Αρχικοποίηση της τιμής ταχύτητας
int turnSpeed = 2000;  // Αρχικοποίηση της τιμής ταχύτητας για τις στροφές

void setup() {
  Serial.begin(9600);  // Έναρξη σειριακής θύρας στη συχνότητα 9600
  pwm.begin();
  pwm.setPWMFreq(60);
  stop();
}

void loop() {
  if (Serial.available() > 0) {
    switch (Serial.read()) {
      case 'F':
        advance();
        Serial.println("advance");
        break;
      case 'B':
        back();
        Serial.println("back");
        break;
      case 'L':
        turnL();
        Serial.println("left");
        break;
      case 'R':
        turnR();
        Serial.println("right");
        break;
      case 'S':
        stop();
        Serial.println("stop");
        break;
      case 'd':
        while ('d') {  // Αν λάβει ‘d’, η ταχύτητα μειώνεται
          Serial.println(speed);
          if (speed >= 5) speed -= 5;  // η ταχύτητα μειώνεται κατά 5 μέχρι να ελάχιστη τιμή το 0
          if (Serial.read() == 'S') {
            Serial.println(speed);
            break;
          }
        }
        break;
      case 'a':
        while ('a') {  // Αν λάβει τον χαρακτήρα ‘a’, η ταχύτητα αυξάνεται
          Serial.println(speed);
          if (speed <= 2555) speed += 5;  // Αυξάνει την ταχύτητα κατά 5, μέχρι να φτάσει 2555
          if (Serial.read() == 'S') {
            Serial.println(speed);
            break;
          }
        }
        break;
    }
  }
}


void advance()  // Κίνηση μπροστά
{
  pwm.setPWM(0, 0, speed);
  pwm.setPWM(1, 0, 0);
  pwm.setPWM(2, 0, speed);
  pwm.setPWM(3, 0, 0);
  pwm.setPWM(4, 0, speed);
  pwm.setPWM(5, 0, 0);
  pwm.setPWM(6, 0, speed);
  pwm.setPWM(7, 0, 0);
}

void turnR()  // Στροφή δεξιά
{
  pwm.setPWM(0, 0, turnSpeed);
  pwm.setPWM(1, 0, 0);
  pwm.setPWM(2, 0, turnSpeed);
  pwm.setPWM(3, 0, 0);
  pwm.setPWM(4, 0, 0);
  pwm.setPWM(5, 0, turnSpeed);
  pwm.setPWM(6, 0, 0);
  pwm.setPWM(7, 0, turnSpeed);
}

void turnL()  // Στροφή αριστερά
{
  pwm.setPWM(0, 0, 0);
  pwm.setPWM(1, 0, turnSpeed);
  pwm.setPWM(2, 0, 0);
  pwm.setPWM(3, 0, turnSpeed);
  pwm.setPWM(4, 0, turnSpeed);
  pwm.setPWM(5, 0, 0);
  pwm.setPWM(6, 0, turnSpeed);
  pwm.setPWM(7, 0, 0);
}

void stop()  // Σταματάει
{
  pwm.setPWM(0, 0, 0);
  pwm.setPWM(1, 0, 0);
  pwm.setPWM(2, 0, 0);
  pwm.setPWM(3, 0, 0);
  pwm.setPWM(4, 0, 0);
  pwm.setPWM(5, 0, 0);
  pwm.setPWM(6, 0, 0);
  pwm.setPWM(7, 0, 0);
}

void back()  // Κίνηση προς τα πίσω
{
  pwm.setPWM(0, 0, 0);
  pwm.setPWM(1, 0, speed);
  pwm.setPWM(2, 0, 0);
  pwm.setPWM(3, 0, speed);
  pwm.setPWM(4, 0, 0);
  pwm.setPWM(5, 0, speed);
  pwm.setPWM(6, 0, 0);
  pwm.setPWM(7, 0, speed);
}