/*
 Δραστηριότητα 1.9
 Προγραμματισμός αισθητήρα υπερήχων και ενεργοποίηση LED και Βομβητή
*/
int trigPin = 12;  // Trigger
int echoPin = 13;  // Echo
long duration, cm, inches;
int led = 3;     // ορίζουμε το LED στο pin 3
int buzzer = 2;  // ρυθμίστε την ψηφιακή καρφίτσα (IO) του βομβητή

void setup() {
  Serial.begin(9600);        // Έναρξη σειριακής θύρας
  pinMode(trigPin, OUTPUT);  // Ορίστε εισόδους και εξόδους
  pinMode(echoPin, INPUT);
  pinMode(led, OUTPUT);
  pinMode(buzzer, OUTPUT);  // ορίζει το ψηφιακό PIN IO, OUTPUT σε έξοδο.
}
void loop() {
  // Ο αισθητήρας ενεργοποιείται από υψηλό παλμό (HIGH) των 10 ή περισσότερων μικροδευτερόλεπτων.
  // Δώστε έναν σύντομο χαμηλό παλμό (LOW) εκ των προτέρων για να εξασφαλίσετε έναν καθαρό υψηλό παλμό (HIGH):
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  // Διαβάστε το σήμα από τον αισθητήρα: ένας υψηλός παλμός (HIGH) του οποίου
  // η διάρκεια είναι ο χρόνος (σε μικροδευτερόλεπτα) από την αποστολή
  // του ping στη λήψη της ηχώ του από ένα αντικείμενο.
  duration = pulseIn(echoPin, HIGH);
  // Μετατρέψτε το χρόνο σε απόσταση
  cm = (duration / 2) / 29.1;    // Διαιρέστε με 29.1 ή πολλαπλασιάστε με 0.0343
  inches = (duration / 2) / 74;  // Διαιρέστε με 74 ή πολλαπλασιάστε με 0.0135
  Serial.print(inches);
  Serial.print("in, ");
  Serial.print(cm);
  Serial.print("cm");
  Serial.println();
  delay(50);
  if (cm >= 2 && cm <= 10) {
    digitalWrite(led, HIGH);

    if (cm >= 2 && cm <= 5) {
      for (int i = 0; i < 80; i++)  // έξοδος ήχου συχνότητας
      {
        digitalWrite(buzzer, HIGH);  // ήχος
        delay(1);                    // καθυστέρηση 1ms
        digitalWrite(buzzer, LOW);   // όχι ήχος
        delay(1);                    // καθυστέρηση 1ms
      }
      for (int i = 0; i < 100; i++)  // έξοδος ήχου συχνότητας
      {
        digitalWrite(buzzer, HIGH);  // ήχος
        digitalWrite(buzzer, LOW);   // όχι ήχος
        delay(2);                    // καθυστέρηση 2ms
      }
    } else {
      for (int i = 0; i < 80; i++)  // έξοδος ήχου συχνότητας
      {
        digitalWrite(buzzer, HIGH);  // ήχος
        delay(1);                    // καθυστέρηση 1ms
        digitalWrite(buzzer, LOW);   // όχι ήχος
        delay(1);                    // καθυστέρηση 1ms
      }
      for (int i = 0; i < 100; i++)  // έξοδος ήχου συχνότητας
      {
        digitalWrite(buzzer, HIGH);  // ήχος
        digitalWrite(buzzer, LOW);   // όχι ήχος
        delay(2);                    // καθυστέρηση 2ms
      }
    }
  } else digitalWrite(led, LOW);
}  //****************************************************************